Bug 1210702 - X server hangs at logout
Summary: X server hangs at logout
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-vmware
Version: 21
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Hans de Goede
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-04-10 11:50 UTC by Ian Collier
Modified: 2015-04-26 12:46 UTC (History)
2 users (show)

Fixed In Version: xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-04-26 12:46:29 UTC
Type: Bug


Attachments (Terms of Use)

Description Ian Collier 2015-04-10 11:50:54 UTC
Description of problem:

System is Fedora 21 running within VMware Workstation 11.1.0, hosted on Windows 7 Enterprise SP1, 64-bit.

Sometimes when user logs out of GNOME, the screen freezes with no mouse pointer; no interaction of any kind seems to work, but forcing a shutdown from VMware does eventually shut the machine down cleanly after a few minutes.

Examining the running X server at the point of the hang shows something like this:

#0  vmwgfx_pixmap_present_readback (vsaa=0xb6a650, pixmap=0xbbab80, region=0xbbabf8) at vmwgfx_saa.c:240
#1  0x00007fdb88bc9d1e in vmwgfx_download_from_hw (driver=0xb6a650, pixmap=0xbbab80, readback=0xbbabf8) at vmwgfx_saa.c:353
#2  0x00007fdb88bcb14d in vmwgfx_saa_drop_master (pScreen=<optimized out>) at vmwgfx_saa.c:1612
#3  0x00007fdb88bc3da3 in drv_leave_vt (arg=0xb01840) at vmwgfx_driver.c:1207
#4  0x00007fdb88bc42e7 in drv_close_screen (pScreen=0xb01290) at vmwgfx_driver.c:1260
#5  0x00000000004aeed7 in xf86CrtcCloseScreen (screen=0xb01290) at xf86Crtc.c:734
#6  0x00000000004cd2a8 in CursorCloseScreen (pScreen=0xb01290) at cursor.c:187
#7  0x0000000000517614 in AnimCurCloseScreen (pScreen=<optimized out>) at animcur.c:106
#8  0x0000000000518f72 in present_close_screen (screen=0xb01290) at present_screen.c:63
#9  0x000000000043d3e7 in dix_main (argc=16, argv=0x7ffd03e71648, envp=<optimized out>) at main.c:349
#10 0x000000349ca1ffe0 in __libc_start_main () from /lib64/libc.so.6
#11 0x00000000004276ee in _start ()

and single-stepping the server shows it is stuck in this loop:

1605        WSBMLISTFOREACH(list, &vsaa->pixmaps) {
1609            if (!vpix->hw)
1612            (void) vmwgfx_download_from_hw(&vsaa->driver, spix->pixmap,
1613                                           &spix->dirty_hw);
1612            (void) vmwgfx_download_from_hw(&vsaa->driver, spix->pixmap,
1614            REGION_EMPTY(draw->pScreen, &spix->dirty_hw);
1605        WSBMLISTFOREACH(list, &vsaa->pixmaps) {

Forcing the vmwgfx_saa_drop_master function to return results in a successful logout.

Version-Release number of selected component (if applicable):
xorg-x11-server-Xorg-1.16.3-2.fc21.x86_64
xorg-x11-drv-vmware-13.0.2-5.20140613git82c9b0c.fc21.x86_64

How reproducible:
Not every time, but logging in and out a few times usually triggers the hang.

Comment 1 Ian Collier 2015-04-10 16:30:56 UTC
The following SUSE bug has a patch which appears to fix this issue.

https://bugzilla.opensuse.org/show_bug.cgi?id=900884

Comment 2 Hans de Goede 2015-04-14 10:27:21 UTC
Thanks for the bug report, I'm preparing a F-21 update with the bug-fix from upstream.

Comment 3 Fedora Update System 2015-04-14 11:02:59 UTC
xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21

Comment 4 Fedora Update System 2015-04-18 09:49:29 UTC
Package xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-6363/xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21
then log in and leave karma (feedback).

Comment 5 Fedora Update System 2015-04-26 12:46:29 UTC
xorg-x11-drv-vmware-13.0.2-8.20150211git8f0cf7c.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.